### Interrupt example ###

# DECLARATIONS OF CONSTANTS
CLS:		.EQU	$10
KEYPAD:	.EQU	$F011
DISP:		.EQU	$F031
LED:		.EQU	$F032

# INITIALIZATION
		.org	$4000
		LDA	CLS
		STA	[DISP]
		BLDSP	$EFFF		#Stack pointer: $EFFF
		BLDIV	READKEY	#Interrupt vector: READKEY
		SETIM			#Interrupt listening active

# RUNNING LIGHTS (The normal run)
BEGIN:	LDA	$01
		STA	[VAR]		
NEXT:		LDA	[VAR]
		STA	[LED]
		SHL
		STA	[VAR]
		CMPA	%10000000
		JZ	[BEGIN]

# DLEAY
		LDA	$A0		#Delay time
WAIT:		DECA
		JNZ 	[WAIT]
		JMP	[NEXT]	#End of delay

# INTERRUPT HANDLER
READKEY:	CLRIM
		PUSHA
		LDA	[KEYPAD]	#Read a character
		JN	[FURTHER]
		STA	[DISP]
FURTHER:	POPA
		RTI

VAR:		.BYTE
		.END		