### RECURSIVE SUBROUTINE ###
DISP:		.EQU	$F031
CLR:		.EQU	$10
KEYPAD:	.EQU	$F011
		.ORG	$4000

# INITIALIZATION
		BLDSP	$EFFF		# INITIALIZATION OF SP

		LDA	CLR		# CLEAR DISPLAY
		STA	[DISP]

# MAIN PROGRAM UNIT
READ:		LDA	[KEYPAD]	# READ DECIMAL DIGIT FROM KEYPAD
		JN	[READ]
		CMPA	$09
		JC	[READ]

		PUSHA			# STORE THE PUSHED DIGIT (PARAMETER)
		JSR	[RECURSIV]	# FIRST CALL OF RECURSIVE SUBROUTINE
		POPA			# CLEAR PARAMETER FROM STACK

		LDA	$20		# A SPACE CHARACTER AS SEPARATOR
		STA	[DISP]
		JMP	[READ]	# START AGAIN

# RECURSIVE SUBROUTINE
RECURSIV:	BSTSP	[TMP]
		BLDX	[TMP]
		PUSHA			# SPACE FOR LOCAL VARIABLE (N)
		LDA	[$0003,X]
		STA	[$0000,X]
		
		LDA	[$0000,X]	# putch(N);
		STA	[DISP]	
		
		LDA	[$0000,X]	# if(N!=0){
		JZ	[BACK]

		LDA	[$0000,X]	# N--;
		DECA
		STA	[$0000,X]

		PUSHA			# PARAMETER INTO STACK
		JSR	[RECURSIV]	# CALL ITSELF
		POPA			# CLEAR PARAMETER FROM STACK

BACK:		POPA			# FREE LOCAL VARIBLE
		RTS			# RETURN TO CALLER

TMP:		.BYTE			# JUST FOR TECHNICAL REASON

		.END

#void RECURSIVE(char N){
#  putch(N);
#  if(N!=0){
#    N--;
#    RECURSIVE(N);
#    }
#  return;
#  }